catalog/urls.py
from django.conf.urls import url
from . import views
from django.urls import include,path
'''
urlpatterns = [
   path('', views.index, name='index'),
]
'''

''' ^$ is a regular expression for an empty string,
thus, when a request of the type 
      http://..../ 
      http://..../catalog/ or

index function in views.py will ve invoked 
 
'''
urlpatterns = [
    url(r'^$', views.index, name='index'),
    url(r'^books/$', views.BookListView.as_view(), name='books'),
    url(r'^books-as-json/$', views.books_as_json, name='books_as_json'),
    url(r'^book/(?P<pk>\d+)$', views.BookDetailView.as_view(), name='book-detail'),
    url(r'^authors/$', views.AuthorListView.as_view(), name='authors'),
    url(r'^author/(?P<pk>\d+)$', views.AuthorDetailView.as_view(), name='author-detail'),
]
urlpatterns += [
    url(r'^my-loaned-books/$', views.LoanedBooksByUserListView.as_view(), name='my-loaned'),
]
urlpatterns += [
    url(r'^all-loaned-books/$', views.LoanedBooksListView.as_view(), name='all-loaned'),
]
urlpatterns += [
    url(r'^book/(?P<pk>[-\w]+)/renew/$', views.renew_book_librarian, name='renew-book-librarian'),
    url(r'^book/(?P<pk>[-\w]+)/return/$', views.return_book_librarian, name='return-book-librarian'),
]

urlpatterns += [
    url(r'^author/create/$', views.AuthorCreate.as_view(), name='author_create'),
    url(r'^author/(?P<pk>\d+)/update/$', views.AuthorUpdate.as_view(), name='author_update'),
    url(r'^author/(?P<pk>\d+)/delete/$', views.AuthorDelete.as_view(), name='author_delete'),
    url(r'^book/create/$', views.BookCreate.as_view(), name='book_create'),
    url(r'^book/(?P<pk>\d+)/update/$', views.BookUpdate.as_view(), name='book_update'),
]

locallibrary/urls.py
from django.contrib import admin
from django.urls import include,path
from django.views.generic import RedirectView
# Use static() to add url mapping to serve static files during development (only)
from django.conf import settings
from django.conf.urls.static import static
from django.conf.urls import url


urlpatterns = [
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
    path('catalog/', include('catalog.urls')),
    path('', RedirectView.as_view(url='/catalog/', permanent=True)),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

''' As the django default account app is not one created by us, it does not have a folder under
    the project directory (an thus, it does not have its own urls.py file). Hence, we must
    configure its urls here at the project level (locallibrary/urls.py) '''

urlpatterns += [
    url(r'^accounts/login/$', include('django.contrib.auth.urls'),  name=['login']),
    url(r'^accounts/logout/$', include('django.contrib.auth.urls'), name=['logout']),
    url(r'^accounts/password_change/$', include('django.contrib.auth.urls'), name=['password_change']),
    url(r'^accounts/password_change/done/$', include('django.contrib.auth.urls'), name=['password_change_done']),
    url(r'^accounts/password_reset/$', include('django.contrib.auth.urls'), name=['password_reset']),
    url(r'^accounts/password_reset/done/$', include('django.contrib.auth.urls'), name=['password_reset_done']),
    url(r'^accounts/reset/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$', include('django.contrib.auth.urls'), name=['password_reset_confirm']),
    url(r'^accounts/reset/done/$', include('django.contrib.auth.urls'), name=['password_reset_complete'])
]

catalog/models.py
from django.db import models
from datetime import date
from django.contrib.auth.models import User
import uuid 

# Create your models here.

class Language(models.Model):
    """Model representing a Language (e.g. English, French, Japanese, etc.)"""
    name = models.CharField(max_length=200,
                            help_text="Enter the book's natural language (e.g. English, French, Japanese etc.)")

    def __str__(self):
        """String for representing the Model object (in Admin site etc.)"""
        return self.name

class Genre(models.Model):
    """
    Modelo que representa un género literario (p. ej. ciencia ficción, poesía, etc.).
    Un campo para el id de la tupla o instancia es añadido automáticamente de tipo AutoField
    """
    name = models.CharField(max_length=200, help_text="Ingrese el nombre del género (p. ej. Ciencia Ficción, Poesía Francesa etc.)")

    def __str__(self):
        """
        Cadena que representa a la instancia particular del modelo (p. ej. en el sitio de Administración)
        """
        return self.name

from django.urls import reverse #Used to generate URLs by reversing the URL patterns

class Book(models.Model):
    """
    Modelo que representa un libro (pero no un Ejemplar específico).
    """

    title = models.CharField(max_length=200)

    author = models.ForeignKey('Author', on_delete=models.SET_NULL, null=True)
    # ForeignKey, ya que un libro tiene un solo autor, pero el mismo autor puede haber escrito muchos libros.
    # 'Author' es un string, en vez de un objeto, porque la clase Author aún no ha sido declarada.

    summary = models.TextField(max_length=1000, help_text="Ingrese una breve descripción del libro")

    isbn = models.CharField('ISBN',max_length=13, help_text='13 Caracteres <a href="https://www.isbn-international.org/content/what-isbn">ISBN number</a>')

    genre = models.ManyToManyField(Genre, help_text="Seleccione un genero para este libro")
    # ManyToManyField, porque un género puede contener muchos libros y un libro puede cubrir varios géneros.
    # La clase Genre ya ha sido definida, entonces podemos especificar el objeto arriba.
    language = models.ForeignKey('Language', on_delete=models.SET_NULL, null=True)

    class Meta:
        ordering = ["isbn"]
        permissions = (
                       ("can_update_book_data", "Update Book Data"),
                      )

    def __str__(self):
        """
        String que representa al objeto Book
        """
        return self.title


    def get_absolute_url(self):
        """
        Devuelve el URL a una instancia particular de Book
        """
        return reverse('book-detail', args=[str(self.id)])

    ''' As book-genre is a many-to-many rel, we'll generat the book genre as
        the first 3 genres joined by ,
    '''

    def display_genre(self):
        """
        Creates a string for the Genre. This is required to display genre in Admin.
        display_genre.short_description will be used as the column header in the
        Admin interface ...
        """
        return ', '.join([ genre.name for genre in self.genre.all()[:3] ])

    display_genre.short_description = 'Genre'

class BookInstance(models.Model):
    '''
    Modelo que representa una copia específica de un libro (i.e. que puede ser prestado por la biblioteca).
    The UUIDField data type generates unique string identifiers of this kind:
              9c02aacf-a391-401c-90f4-9844fb0194c2

    From the ForeignKey definition below, we can see that there is a  Book(1) - (N)BookInstance
    relationtion (we did not specify anything in parent entity). This allow us to reach all the
    BookInstance instances for a particular Book using book.bookinstance_set.all. The same applies
    for Author (where we do not specify anithing) and Books (where we set up another ForeignKey)
    '''
    id = models.UUIDField(primary_key=True, default=uuid.uuid4, help_text="ID único para este libro particular en toda la biblioteca")
    book = models.ForeignKey('Book', on_delete=models.SET_NULL, null=True)
    borrower = models.ForeignKey(User, on_delete=models.SET_NULL, null=True, blank=True)
    imprint = models.CharField(max_length=200)
    due_back = models.DateField(null=True, blank=True)

    LOAN_STATUS = (
        ('m', 'Maintenance'),
        ('o', 'On loan'),
        ('a', 'Available'),
        ('r', 'Reserved'),
    )

    '''
        get_status_display is a method that can be used in the corresponding
        detail template to access de status description (FROM LOAN_STATUS)
        instead of status code), for better usability
        (see templates/catalog/book_detail.html)
    '''

    status = models.CharField(max_length=1, choices=LOAN_STATUS, blank=True, default='m', help_text='Disponibilidad del libro')

    class Meta:
        ordering = ["due_back"]
        permissions = (
                       ("can_mark_returned", "Set book as returned"),
                       ("can_list_all_borrowed", "List all borrowed books")
                      )


    def __str__(self):
        """
        String para representar el Objeto del Modelo
        """
        return '%s [%s - %s]' % (self.id,self.book.title, self.book.author)

    @property
    def is_overdue(self):
        if self.due_back and date.today() > self.due_back:
            return True
        return False

    @property
    def is_available(self):
        if self.status == 'a':
            return True
        return False
    

class Author(models.Model):

    """
    Modelo que representa un autor
    """
    first_name = models.CharField(max_length=100)
    last_name = models.CharField(max_length=100)
    date_of_birth = models.DateField(null=True, blank=True)
    date_of_death = models.DateField('Died', null=True, blank=True)

    def get_absolute_url(self):
        """
        Retorna la url para acceder a una instancia particular de un autor.
        example : '/catalog/author/1' 
        """
        return reverse('author-detail', args=[str(self.id)])

    class Meta:
        permissions = (
                       ("can_update_author_data", "Update Author Data"),
                      )

    def __str__(self):
        """
        String para representar el Objeto Modelo
        """
        return '%s, %s' % (self.last_name, self.first_name)

catalog/forms.py
from django import forms
from django.core.exceptions import ValidationError
from django.utils.translation import ugettext_lazy as _
import datetime #for checking renewal date range.

class RenewBookForm(forms.Form):
    renewal_date = forms.DateField(help_text="Enter a date between now and 4 weeks (default 3).")

    def clean_renewal_date(self):
        data = self.cleaned_data['renewal_date']

        #Check date is not in past.
        if data < datetime.date.today():
            raise ValidationError(_('Invalid date - renewal in past'))

        #Check date is in range librarian allowed to change (+4 weeks).
        if data > datetime.date.today() + datetime.timedelta(weeks=4):
            raise ValidationError(_('Invalid date - renewal more than 4 weeks ahead'))

        # Remember to always return the cleaned data.
        return data

catalog/views.py
from django.shortcuts import render
from django.http import HttpResponse
from django.views import generic
from django.contrib.auth.decorators import permission_required
from django.views.generic.edit import CreateView, UpdateView, DeleteView
from django.urls import reverse_lazy
from .models import Author

""" Nos permite que el acceso a una vista GENERICA este restringido a 
    usuarios loggeados. Las funciones de vista que hereden de esta clase
    tendrán esa característica """
from django.contrib.auth.mixins import LoginRequiredMixin, PermissionRequiredMixin

''' Para el manejo de la vista que renderiza el formulñario '''
from django.shortcuts import get_object_or_404
from django.http import HttpResponseRedirect
from django.urls import reverse
import datetime

from .forms import RenewBookForm

''' for JSON response example '''
from django.http import JsonResponse


'''
def index(request):
    return HttpResponse("Hello, world. You're at the polls index.")
'''

from .models import Book, Author, BookInstance, Genre

def index(request):
    """
    Función vista para la página inicio del sitio.
    """
    # Genera contadores de algunos de los objetos principales
    num_genres=Genre.objects.all().count()
    num_books=Book.objects.all().count()
    num_instances=BookInstance.objects.all().count()
    # Libros disponibles (status = 'a')
    num_instances_available=BookInstance.objects.filter(status__exact='a').count()
    num_authors=Author.objects.count()  # El 'all()' esta implícito por defecto.

    # Numero de visitas a esta view, como está contado en la variable de sesión.
    num_visits = request.session.get('num_visits', 0)
    request.session['num_visits'] = num_visits + 1


    # Renderiza la plantilla HTML index.html con los datos en la variable contexto
    return render(
        request,
        'index.html',
        context={   
                    'num_visits': num_visits,
                    'num_genres':num_genres,
                    'num_books':num_books,
                    'num_instances':num_instances,
                    'num_instances_available':num_instances_available,
                    'num_authors':num_authors
                },
    )

''' SORT OF REST endpoint '''
def books_as_json(request):
    #users = Book.objects.all().values('first_name', 'last_name')  # or simply .values() to get all fields
    books = Book.objects.all().values()
    book_list = list(books)  # important: convert the QuerySet to a list object
    return JsonResponse(book_list, safe=False)


''' Generic views ...
    For generic views, templates must be placed at /[app]/templates/[app] '''

class BookListView(generic.ListView):
    model = Book
    paginate_by = 5

class BookDetailView(generic.DetailView):
    model = Book

class AuthorListView(generic.ListView):
    model = Author
    paginate_by = 5

class AuthorDetailView(generic.DetailView):
    model = Author


class LoanedBooksByUserListView(LoginRequiredMixin,generic.ListView):
    """
    Generic class-based view listing books on loan to current user.
    """
    model = BookInstance
    template_name ='catalog/bookinstance_list_borrowed_user.html'
    paginate_by = 10

    """ We want to retrieve only those instances which has been borrowed
        (status = o), to the user in session """
        
    def get_queryset(self):
        return BookInstance.objects.filter(borrower=self.request.user).filter(status__exact='o').order_by('due_back')



class LoanedBooksListView(LoginRequiredMixin,generic.ListView):
    """
    Generic class-based view listing books on loan by all users user.
    """
    model = BookInstance
    permission_required = 'catalog.can_mark_returned'
    template_name ='catalog/bookinstance_list_borrowed.html'
    paginate_by = 10

    def get_queryset(self):
        return BookInstance.objects.filter(status__exact='o').order_by('due_back')

''' En una función típica esta es la forma de controlar el acceso a ella por permisos '''
@permission_required('catalog.can_mark_returned')
def renew_book_librarian(request, pk):
    """
    View function for renewing a specific BookInstance by librarian
    """
    book_inst=get_object_or_404(BookInstance, pk = pk)

    # If this is a POST request then process the Form data
    if request.method == 'POST':

        # Create a form instance and populate it with data from the request (binding):
        form = RenewBookForm(request.POST)

        # Check if the form is valid:
        if form.is_valid():
            # process the data in form.cleaned_data as required (here we just write it to the model due_back field)
            book_inst.due_back = form.cleaned_data['renewal_date']
            book_inst.save()

            # redirect to a new URL:
            return HttpResponseRedirect(reverse('all-loaned') )

    # If this is a GET (or any other method) create the default form.
    else:
        proposed_renewal_date = datetime.date.today() + datetime.timedelta(weeks=3)
        form = RenewBookForm(initial={'renewal_date': proposed_renewal_date,})

    return render(request, 'catalog/book_renew_librarian.html', {'form': form, 'bookinst':book_inst})


@permission_required('catalog.can_mark_returned')
def return_book_librarian(request, pk):
    """
    View function for renewing a specific BookInstance by librarian
    """
    book_inst=get_object_or_404(BookInstance, pk = pk)

    if request.method == 'POST':
        book_inst.due_back = None
        book_inst.status = 'a'
        book_inst.save()
        return HttpResponseRedirect(reverse('all-loaned'))

    else:
        context = {'bookinst': book_inst}
        return render(request, 'catalog/book_return_librarian.html', context)


''' Vistas Genéricas de Formularios '''

''' En una vista basada en clases esta es la forma controlar el acceso a ella por permisos '''
class AuthorCreate(PermissionRequiredMixin,CreateView):
    permission_required = 'catalog.can_update_author_data'
    model = Author
    fields = '__all__'
    initial={'date_of_death':'05/01/2018',}


class AuthorUpdate(PermissionRequiredMixin,UpdateView):
    permission_required = 'catalog.can_update_author_data'
    model = Author
    fields = ['first_name','last_name','date_of_birth','date_of_death']

class AuthorDelete(PermissionRequiredMixin, DeleteView):
    permission_required = 'catalog.can_update_author_data'
    model = Author
    success_url = reverse_lazy('authors')

class BookCreate(PermissionRequiredMixin,CreateView):
    permission_required = 'catalog.can_update_book_data'
    model = Book
    fields = '__all__'
    initial={'title':'Your book title here ...',}

class BookUpdate(PermissionRequiredMixin,UpdateView):
    permission_required = 'catalog.can_update_book_data'
    model = Book
    fields = '__all__'

catalog/templates/catalog/author_confirm_delete.html
{% extends "base_generic.html" %}

{% block content %}

<h1>Delete Author</h1>

<p>Are you sure you want to delete the author: {{ author }}?</p>

<form action="" method="POST">
  {% csrf_token %}
  <input type="submit" action="" value="Yes, delete." />
</form>

{% endblock %}

catalog/templates/catalog/author_detail.html
{% extends "base_generic.html" %}

{% block content %}
  <h1>Author: {{ author.last_name }}, {{ author.first_name }}</h1> <h3>{% if perms.catalog.can_update_author_data %} <a href="{% url 'author_update' author.id %}">[Edit]</a>  {% endif %}</h3>
  {{ author.date_of_birth }} - {% if author.date_of_death %} {{ author.date_of_death }} {% endif %}
  <div style="margin-left:20px;margin-top:20px">
    <h4>Books</h4>
    {% for book in author.book_set.all %}
        <li>
            <a href="{{ book.get_absolute_url }}">{{ book.title }}</a>
        </li>
        {{ book.summary}}
    {% endfor %}
  </div>
{% endblock %}

catalog/templates/catalog/author_form.html
<!-- This template is used for both the generic form views AuthorCreate and AuthorUpdate-->
{% extends "base_generic.html" %}

{% block content %}
<h1>Register/Update an Author</h1>

<form action="" method="post">
    {% csrf_token %}
    <table>
    {{ form.as_table }}
    </table>
    <input type="submit" value="Submit" />

</form>
{% endblock %}

catalog/templates/catalog/author_list.html
{% extends "base_generic.html" %}

{% block content %}
    <h1>Author List</h1>

    {% if author_list %}
    <ul>

      {% for author in author_list %}
      <li>
        <a href="{{ author.get_absolute_url }}">{{ author.last_name }}, {{ author.first_name}}</a>
      </li>
      {% endfor %}

    </ul>
    {% else %}
      <p>There are no Authors in the library.</p>
    {% endif %}
    <h4>
      {% if perms.catalog.can_update_data %} 
      <a href="{% url 'author_create' %}">[Add Author]</a>  
      {% endif %}
    </h4> 
{% endblock %}

catalog/templates/catalog/book_detail.html
{% extends "base_generic.html" %}

{% block content %}
  <h1>Title: {{ book.title }} </h1> <h3>{% if perms.catalog.can_update_book_data %} <a href="{% url 'book_update' book.id %}">[Edit]</a>  {% endif %}</h3>

  <p><strong>Author:</strong> <a href="{{ book.author.get_absolute_url }}">{{ book.author }}</a></p> <!-- author detail link not yet defined -->
  <p><strong>Summary:</strong> {{ book.summary }}</p>
  <p><strong>ISBN:</strong> {{ book.isbn }}</p>
  <p><strong>Language:</strong> {{ book.language }}</p>
  <p><strong>Genre:</strong> {% for genre in book.genre.all %} {{ genre }}{% if not forloop.last %}, {% endif %}{% endfor %}</p>

  <div style="margin-left:20px;margin-top:20px">
    <h4>Copies</h4>

    {% for copy in book.bookinstance_set.all %}
    <hr>
    <p class="{% if copy.status == 'a' %}text-success{% elif copy.status == 'm' %}text-danger{% else %}text-warning{% endif %}">{{ copy.get_status_display }}</p>
    {% if copy.status != 'a' %}<p><strong>Due to be returned:</strong> {{copy.due_back}}</p>{% endif %}
    <p><strong>Imprint:</strong> {{copy.imprint}}</p>
    <p class="text-muted"><strong>Id:</strong> {{copy.id}}</p>
    {% endfor %}
  </div>
{% endblock %}

catalog/templates/catalog/book_form.html
<!-- This template is used for both the generic form views AuthorCreate and AuthorUpdate-->
{% extends "base_generic.html" %}

{% block content %}
<h1>Register/Update a Book</h1>

<form action="" method="post">
    {% csrf_token %}
    <table>
    {{ form.as_table }}
    </table>
    <input type="submit" value="Submit" />

</form>
{% endblock %}

catalog/templates/catalog/book_list.html
{% extends "base_generic.html" %}

{% block content %}
    <h1>Book List</h1>
    {% if book_list %}
    <ul>

      {% for book in book_list %}
      <li>
        <a href="{{ book.get_absolute_url }}">{{ book.title }}</a> ({{book.author}})
      </li>
      {% endfor %}

    </ul>
    {% else %}
      <p>There are no books in the library.</p>
    {% endif %}
    <h4>
      {% if perms.catalog.can_update_data %} 
      <a href="{% url 'book_create' %}">[Add Book]</a>  
      {% endif %}
    </h4>

{% endblock %}

catalog/templates/catalog/book_renew_librarian.html
{% extends "base_generic.html" %}
{% block content %}

    <h1>Renew: {{bookinst.book.title}}</h1>
    <p>Borrower: {{bookinst.borrower}}</p>
    <p{% if bookinst.is_overdue %} class="text-danger"{% endif %}>Due date: {{bookinst.due_back}}</p>

    <form action="" method="post">
        {% csrf_token %}
        <table>
        {{ form }}
        </table>
        <input type="submit" value="Submit" />
    </form>

{% endblock %}

catalog/templates/catalog/book_return_librarian.html
{% extends "base_generic.html" %}
{% block content %}

    <h1>Return: {{bookinst.book.title}}</h1>
    <p>Copy Id: {{bookinst.id}} </p>
    <p>Borrower: {{bookinst.borrower}}</p>
    <p{% if bookinst.is_overdue %} class="text-danger"{% endif %}>Due date: {{bookinst.due_back}}</p>

    
    <form action="{% url 'return-book-librarian' bookinst.id %}" method="post">
        {% csrf_token %}
        <input type="submit" value="Submit" />
    </form>
{% endblock %}

catalog/templates/catalog/bookinstance_list_borrowed.html
{% extends "base_generic.html" %}

{% block content %}
    <h1>Borrowed books</h1>

    {% if bookinstance_list %}
    <ul>

      {% for bookinst in bookinstance_list %}
      <li class="{% if bookinst.is_overdue %}text-danger{% endif %}">
        <a href="{% url 'book-detail' bookinst.book.pk %}">{{bookinst.id}}</a>
        {{ bookinst.book.title }}
        {{ bookinst.due_back }}
        {{bookinst.borrower}}
        {% if perms.catalog.can_mark_returned %}
        - <a href="{% url 'renew-book-librarian' bookinst.id %}">Renew</a>
        - <a href="{% url 'return-book-librarian' bookinst.id %}">Return</a>
        {% endif %}
      </li>
      {% endfor %}
    </ul>

    {% else %}
      <p>There are no books borrowed.</p>
    {% endif %}
{% endblock %}

catalog/templates/catalog/bookinstance_list_borrowed_user.html
{% extends "base_generic.html" %}

{% block content %}
    <h1>Borrowed books</h1>

    {% if bookinstance_list %}
    <ul>

      {% for bookinst in bookinstance_list %}
      <li class="{% if bookinst.is_overdue %}text-danger{% endif %}">
        <a href="{% url 'book-detail' bookinst.book.pk %}">{{bookinst.book.title}}</a> ({{ bookinst.due_back }})
      </li>
      {% endfor %}
    </ul>

    {% else %}
      <p>There are no books borrowed.</p>
    {% endif %}
{% endblock %}